=== debian/changelog ===
ros-indigo-csm (1.0.2-2trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Isaac I.Y. Saito <130s@2000.jukuin.keio.ac.jp>  Sun, 08 Nov 2015 06:23:55 -0000
